package top.ninwoo.edgecenter.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import top.ninwoo.edgecenter.service.IpService;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * @Author joliu
 * @Description
 * @Date　Create in 下午8:20 2019/11/7
 */
@Service
public class IpServiceImpl implements IpService {

    private static final String ASSIGN_IP = "/assignIp";
    private static final String GET_IP_BY_CONTAINERID = "/getIpByContainerId";

    @Value("${bs.cloud.ip}")
    private String ipServiceHost;

    @Autowired
    RestTemplate restTemplate;


    ConcurrentHashMap<String, AtomicInteger> countMap = new ConcurrentHashMap<>();
    ConcurrentHashMap<String, String> ipMap = new ConcurrentHashMap<>();


    // TODO: 这个应该结合数据库，由云端提供服务，暂时提供一个测试版本
    @Override
    public String assignIpString(long clusterId, String appName, String containerId, String networkSegment) {
        Map<String, Object> map = new HashMap<>();
        map.put("clusterId", clusterId);
        map.put("appName", appName);
        map.put("cid", containerId);
        map.put("ipRange", networkSegment);
        ResponseEntity<String> forEntity = restTemplate.getForEntity("http://" + ipServiceHost + ASSIGN_IP, String.class, map);
        if (!forEntity.getStatusCode().is2xxSuccessful()) {
            throw new RuntimeException("获取ip失败" + forEntity.getBody());
        }
        return forEntity.getBody();
    }

    @Override
    public String getContainerIp(String containerId) {
        if(!ipMap.containsKey(containerId)) {
            throw new RuntimeException("docker容器并没有设置ip地址");
        }
        return ipMap.get(containerId);
    }
}
